// KeywordManager.cpp
// (c) 2003 exeal

#include "StdAfx.h"
#include "KeywordManager.h"
#include <algorithm>	// binary_search

using Ascension::CKeywordManager;


bool _CompareKeyword(const wchar_t* psz1, const wchar_t* psz2) {
	return ::StrCmpW(psz1, psz2) < 0;
}

bool _CompareKeywordNoCase(const wchar_t* psz1, const wchar_t* psz2) {
	return ::StrCmpIW(psz1, psz2) < 0;
}


// CKeywordManager class implementation
/////////////////////////////////////////////////////////////////////////////

///	fXgN^
CKeywordManager::~CKeywordManager() {
	Clear();
}

///	L[[h̒ǉBłɓ̂ƉȂ
void CKeywordManager::Add(const wstring& strKeyword) {
	wchar_t*	pszNew = 0;

	// ɕׂ
	for(std::vector<wchar_t*>::size_type i = 0; i < m_vecKeywords.size(); ++i) {
		if(m_vecKeywords[i] == strKeyword)
			return;
		else if(m_vecKeywords[i] > strKeyword) {
			std::vector<wchar_t*>::iterator	it = m_vecKeywords.begin();

			pszNew = new wchar_t[strKeyword.length() + 1];
			wcscpy(pszNew, strKeyword.c_str());
			m_vecKeywords.insert(it + i, pszNew);
			return;
		}
	}
	// Ōɒǉ
	pszNew = new wchar_t[strKeyword.length() + 1];
	wcscpy(pszNew, strKeyword.c_str());
	m_vecKeywords.push_back(pszNew);
}

///	L[[hSč폜
void CKeywordManager::Clear() {
	vector<wchar_t*>::iterator	it = m_vecKeywords.begin();
	while(it != m_vecKeywords.end()) {
		delete[] *it;
		it = m_vecKeywords.erase(it);
	}
}

///	<var>pszText</var> ̐擪ɈvL[[hA݂邩ǂԂ
bool CKeywordManager::Find(const wchar_t* pszText, size_t cch, bool bIgnoreCase) const {
	assert(pszText != 0);

	if(m_vecKeywords.size() == 0 || cch == 0)
		return false;

	wchar_t	chOrg = pszText[cch];	// XbhZ[tłȂ@
	const_cast<wchar_t*>(pszText)[cch] = 0;
	bool	bFound = std::binary_search(m_vecKeywords.begin(), m_vecKeywords.end(),
						pszText, bIgnoreCase ? _CompareKeywordNoCase : _CompareKeyword);
	const_cast<wchar_t*>(pszText)[cch] = chOrg;
	return bFound;
}

/* [EOF] */